# FluxTraining.jl

[Docs (master)](https://fluxml.ai/FluxTraining.jl/dev/)

A powerful, extensible neural net training library.

*FluxTraining.jl* gives you an endlessly extensible training loop for deep learning inspired by [fastai](https://docs.fast.ai)'s training loop. It is the training backend for [FastAI.jl](https://github.com/FluxML/FastAI.jl).

It exposes a small set of extensible interfaces and uses them to implement

- hyperparameter scheduling
- metrics
- logging
- training history; and
- model checkpointing

Install using `]add FluxTraining`.

Read [getting started](docs/getting_started.md) first and the [user guide](docs/overview.md) if you want to know more.
